;												
; RDS-SIGNALGENERATOR fr ATmega8				
; Bernhard.Erfurt@gmx.de						
; 05/2014										
; VERSION 2										

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> OUT RDS-Analog						
; PB1 ==> OUT 19kHz-Generator (Pilotton)		
; PB2 ==> 										
; PB3 ==> OUT 57kHz-GENERATOR 					
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> OUT RDS-TAKT							
; PC1 ==> OUT RDS-DATA							
; PC2 ==> 										
; PC3 ==> LED ROT								
; PC4 ==> LED GELB								
; PC5 ==> LED GRN								
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> INPUT (vom 57kHz Generator)			
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> 										
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT							=16000000	
; TIMER-WERTE										
.equ TIMERWERT0 					=256-146	; 146 berwachungstimer ;(2 hoch 8  minus...)	
.equ TIMERCTC19kHz					=419		; 19kHz	
.equ TIMERCTC57kHz					=139		; 57kHz (139 bei 15.960.000 Takt)	

; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRC
.equ LED_GRUEN_PORT					= PORTC
; LED-GELB										
.equ LED_GELB_PIN_NR				= 4
.equ LED_GELB_DDR					= DDRC
.equ LED_GELB_PORT					= PORTC
; LED-ROT										
.equ LED_ROT_PIN_NR					= 3
.equ LED_ROT_DDR					= DDRC
.equ LED_ROT_PORT					= PORTC
; AUSGANG-19kHz (CTC-Timer1)					
.equ AUSGANG_19kHz_PIN_NR			= 1
.equ AUSGANG_19kHz_DDR				= DDRB
.equ AUSGANG_19kHz_PORT				= PORTB
; AUSGANG-57kHz (CTC-Timer2)					
.equ AUSGANG_57kHz_PIN_NR			= 3
.equ AUSGANG_57kHz_PIN				= PINB
.equ AUSGANG_57kHz_DDR				= DDRB
.equ AUSGANG_57kHz_PORT				= PORTB
; AUSGANG-RDS-57kHz-analog						
.equ AUSGANG_RDS_ANALOG_PIN_NR		= 0
.equ AUSGANG_RDS_ANALOG_DDR			= DDRB
.equ AUSGANG_RDS_ANALOG_PORT		= PORTB
; AUSGANG-RDS-TAKT								
.equ AUSGANG_RDS_TAKT_PIN_NR		= 0
.equ AUSGANG_RDS_TAKT_DDR			= DDRC
.equ AUSGANG_RDS_TAKT_PORT			= PORTC
; AUSGANG-RDS-DATA								
.equ AUSGANG_RDS_DATA_PIN_NR		= 1
.equ AUSGANG_RDS_DATA_DDR			= DDRC
.equ AUSGANG_RDS_DATA_PORT			= PORTC

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						= SRAM_START		; 0x0060 START Adresse 		

.equ adr_RDS_DATA_ZEIGER_L			= SRAM_START+10
.equ adr_RDS_DATA_ZEIGER_H			= SRAM_START+11


.equ adr_RDS_DATA_BUFFER13			= SRAM_START+900

.equ adr_SRAM_CHECK					= SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										

.def KOPIE_SREG			= R0	; SREG (INTERRUPT)
.def KOPIE_TEMP			= R1	; TEMP (INTERRUPT)
.def KOPIE_ZL			= R2
.def KOPIE_ZH			= R3

.def TIMER0WERT			= R4	; Kontrolltimer		

.def RDS_ZAEHLER_TAKTKORREKTUR	= R5	; CTC 				
.def RDS_SINUS			= R6
.def RDS_ZAEHLER_BITS	= R8
.def RDS_INVERTIERUNG	= R10
.def RDS_DATA			= R11

.def NULL 				= R14
.def EINS 				= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp RDS_GENERATOR 		; IRQ0 Handler                      					
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; TIMER0 Startwert	
	ldi temp,(TIMERWERT0)
	mov TIMER0WERT,temp
	; RDS				
	clr RDS_SINUS
	clr RDS_ZAEHLER_BITS
	clr RDS_ZAEHLER_TAKTKORREKTUR
	clr RDS_INVERTIERUNG
	; RDS DATA-Tabelle	
	ldi ZL,LOW (DATA*2)
	ldi ZH,HIGH(DATA*2)
	STS(adr_RDS_DATA_ZEIGER_L),ZL
	STS(adr_RDS_DATA_ZEIGER_H),ZH
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; PORT B+C+C initialisieren								
	out DDRB, NULL
	out DDRC, NULL
	out DDRD, NULL
	out PORTB,NULL
	out PORTC,NULL
	out PORTD,NULL
; PORT LED											
	; auf AUSGANG									
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT	
	; LEDs an									
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
; AUSGANG-A										
	sbi (AUSGANG_19kHz_DDR),(AUSGANG_19kHz_PIN_NR)				; 19kHz-Generator
	sbi (AUSGANG_57kHz_DDR),(AUSGANG_57kHz_PIN_NR)				; 57kHz-Generator

	sbi (AUSGANG_RDS_ANALOG_DDR),(AUSGANG_RDS_ANALOG_PIN_NR)	; RDS-Analog	
	sbi (AUSGANG_RDS_TAKT_DDR),(AUSGANG_RDS_TAKT_PIN_NR)		; RDS-TAKT		
	sbi (AUSGANG_RDS_DATA_DDR),(AUSGANG_RDS_DATA_PIN_NR)		; RDS-DATA		
; AUSGNGE auf LOW								
	cbi (AUSGANG_19kHz_PORT)  ,(AUSGANG_19kHz_PIN_NR)			; 19kHz-Generator
	cbi (AUSGANG_57kHz_PORT)  ,(AUSGANG_57kHz_PIN_NR)			; 57kHz-Generator

	cbi (AUSGANG_RDS_ANALOG_PORT),(AUSGANG_RDS_ANALOG_PIN_NR)	; Analog 57kHz	
	cbi (AUSGANG_RDS_TAKT_PORT)  ,(AUSGANG_RDS_TAKT_PIN_NR)		; RDS-TAKT		
	cbi (AUSGANG_RDS_DATA_PORT)  ,(AUSGANG_RDS_DATA_PIN_NR)		; RDS-DATA		
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; 	PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; EXTERNER-INTERUPT									
	rcall EXTERNER_INTERUPT_INITIALISIEREN
	rcall EXTERNER_INTERRUPT_AKTIVIEREN
; CTC-TIMER1+2										
	rcall TIMER1_CTC_INITIALISIERUNG
	rcall TIMER2_CTC_INITIALISIERUNG
	rcall TIMER0_INITIALISIERUNG
	rcall TIMER_AKTIVIEREN
	rcall TIMER_SYNCHRONISATION
; Interrupts freigeben								
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET		
	rcall RDS_TESTDATEN
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_TESTDATEN:
	; Z-Initalisieren		
	LDS ZL,(adr_RDS_DATA_ZEIGER_L)
	LDS ZH,(adr_RDS_DATA_ZEIGER_H)
	LPM temp, Z   			; aus Tabelle laden 
	; Ende Tabelle erreicht ?
	tst temp
	brne RDS_TESTDATEN_w
	; Z-Initalisieren		
	ldi ZL,LOW (DATA*2)
	ldi ZH,HIGH(DATA*2)
;-------------------------------------------------------------------------------
RDS_TESTDATEN_w:
	rcall RDS_DATA_TABELLE_Z
	; Z-speichern			
	adiw ZL,1 ;+1
	STS(adr_RDS_DATA_ZEIGER_L),ZL
	STS(adr_RDS_DATA_ZEIGER_H),ZH

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 13 Daten-Bytes 4x(16+10) in den Puffer schieben								
RDS_DATA_TABELLE_Z:
	SLEEP
	tst RDS_ZAEHLER_BITS
	brne RDS_DATA_TABELLE_Z
	tst RDS_SINUS
	brne RDS_DATA_TABELLE_Z
;-------------------------------------------------------------------------------
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	; Y-Initalisieren	
	ldi YL,LOW (adr_RDS_DATA_BUFFER13)
	ldi YH,HIGH(adr_RDS_DATA_BUFFER13)
	; SCHLEIFE			
	ldi temp9,13
RDS_DATA_TABELLE_Z_s:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen
	ST Y+,temp				; im SRAM ablegen							
	dec temp9
	brne RDS_DATA_TABELLE_Z_s
;-------------------------------------------------------------------------------
	; Zwangspause, damit LED sichtbar flackert		
	ldi temp9,255	; SCHLEIFE			
RDS_DATA_TABELLE_Z_s2:
	SLEEP
	dec temp9
	brne RDS_DATA_TABELLE_Z_s2
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "RDS_SIGNAL_TIMER.asm"
.include "RDS_SIGNAL_EXTINTERRUPT.asm"
.include "RDS_SIGNAL_SONSTIGES.asm"			; sonstiges						
.include "RDS_SIGNAL_WAIT_16MHZ.asm"		; 16 MHz						

TABELLE_TAKTKORREKTUR_16MHz:	; 57 / 144kHz	
.db 140,141,140,140,141,140,140,141,140,141,140,140,141,140,140,141,140,140,141,140,140,141,140,140,141,140,140,141,140,141,140,140,141,140,140,141,140,140,141,140,140,141,140,140,141,140,140,141,140,141,140,140,141,140,140,141,140,0

DATA:	
.db 0xD4,0xF6,0xC6,0x51,0x00,0x00,0xF0,0x00,0x05,0xA3,0x9A,0x11,0x70	; ZEIT
.db 0xD4,0xF6,0xC6,0x41,0x02,0x1E,0xB6,0x56,0x48,0x85,0x09,0x14,0x38
.db 0xD4,0xF6,0xC6,0x41,0x02,0x45,0x26,0x56,0x48,0x85,0x49,0x3A,0xFB
.db 0xD4,0xF6,0xC6,0x41,0x02,0xA9,0x96,0x56,0x48,0x85,0x21,0x05,0x84
.db 0xD4,0xF6,0xC6,0x41,0x02,0xF2,0x06,0x56,0x48,0x85,0x49,0x12,0x8A
.db 0xD4,0xF6,0xC6,0x49,0x00,0x14,0x75,0x24,0x49,0x59,0x4C,0xB6,0x1C
.db 0xD4,0xF6,0xC6,0x49,0x00,0x4F,0xE4,0x76,0x56,0x3D,0xB9,0x95,0x79
.db 0xD4,0xF6,0xC6,0x49,0x00,0xA3,0x57,0x26,0x17,0x69,0xD1,0xBC,0xE2
.db 0xD4,0xF6,0xC6,0x49,0x00,0xF8,0xC7,0x22,0x01,0x50,0xC0,0xD6,0x8C
.db 0xD4,0xF6,0xC6,0x49,0x01,0x21,0xA2,0xF3,0x26,0x00,0xC0,0xC5,0xD1
.db 0xD4,0xF6,0xC6,0x49,0x01,0x7A,0x33,0x42,0x01,0xED,0x09,0x96,0xFF
.db 0xD4,0xF6,0xC6,0x49,0x01,0x96,0x87,0x26,0xED,0x3D,0xA1,0x84,0xEC
.db 0xD4,0xF6,0xC6,0x49,0x01,0xCD,0x17,0x26,0x4C,0xF8,0xB9,0x15,0x59
.db 0xD4,0xF6,0xC6,0x49,0x02,0x24,0x47,0x26,0x61,0x31,0xD5,0xCA,0x66
.db 0xD4,0xF6,0xC6,0x49,0x02,0x7F,0xD7,0x44,0x01,0xB1,0x9D,0xB5,0xFF
.db 0xD4,0xF6,0xC6,0x49,0x02,0x93,0x67,0x82,0xE6,0x65,0x91,0x97,0x98
.db 0xD4,0xF6,0xC6,0x49,0x02,0xC8,0xF2,0x04,0x1D,0x25,0x51,0xB4,0x3F
.db 0xD4,0xF6,0xC6,0x49,0x03,0x11,0x96,0x56,0x73,0xA9,0x84,0xE2,0x5B
.db 0xD4,0xF6,0xC6,0x49,0x03,0x4A,0x02,0xD3,0x1B,0xCC,0xD9,0x36,0x08
.db 0xD4,0xF6,0xC6,0x49,0x03,0xA6,0xB4,0x87,0xA7,0xA0,0x81,0x59,0xBC
.db 0xD4,0xF6,0xC6,0x49,0x03,0xFD,0x26,0x57,0x26,0xC5,0xCD,0xA6,0xD9
.db 0xD4,0xF6,0xC6,0x49,0x04,0x2F,0x86,0xF6,0xE2,0xC4,0xC8,0x82,0x6F
.db 0xD4,0xF6,0xC6,0x49,0x04,0x74,0x15,0x46,0x12,0xF5,0xAD,0xD0,0xD3
.db 0xD4,0xF6,0xC6,0x49,0x04,0x98,0xA3,0xA2,0x07,0xA8,0xC4,0xD8,0x9B
.db 0xD4,0xF6,0xC6,0x49,0x04,0xC3,0x34,0xD4,0x81,0x39,0xE8,0xB8,0xFD
.db 0xD4,0xF6,0xC6,0x49,0x05,0x1A,0x52,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x05,0x41,0xC2,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x05,0xAD,0x72,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x05,0xF6,0xE2,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x06,0x1F,0xB2,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x06,0x44,0x22,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x06,0xA8,0x92,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x06,0xF3,0x02,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x07,0x2A,0x62,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x07,0x71,0xF2,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x07,0x9D,0x42,0xE2,0xEA,0xF4,0xB8,0xBA,0x61
.db 0xD4,0xF6,0xC6,0x49,0x07,0xC6,0xD2,0xE2,0xEA,0xF4,0xB9,0x15,0x59
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 ; NULL


